// dropdownDlg.cpp : implementation file
//

#include "stdafx.h"
#include "resource.h"
#include "dropdownDlg.h"
#include "hook.h"
#include "ErrorString.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif

#define IDT_SHOWTIME 1

#ifdef _DEBUG
#define SHOWTIME_SLOW     10000
#define SHOWTIME_FAST      2000
#else
#define SHOWTIME_SLOW     10000
#define SHOWTIME_FAST       350
#endif

#define RIGHT_LIMIT_INDEX  0
#define LEFT_LIMIT_INDEX   1
#define TOP_LIMIT_INDEX    2
#define BOTTOM_LIMIT_INDEX 3

static UINT UWM_HOOK_MOUSEMOVE = ::RegisterWindowMessage(UWM_HOOK_MOUSEMOVE_MSG);

// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
        CAboutDlg();

// Dialog Data
        enum { IDD = IDD_ABOUTBOX };

        protected:
        virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support

// Implementation
protected:
        DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
        CDialog::DoDataExchange(pDX);
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
END_MESSAGE_MAP()

// CdropdownDlg dialog

/****************************************************************************
*                         CdropdownDlg::CdropdownDlg
* Inputs:
*       CWnd * parent: Parent window
* Effect: 
*       Constructor
****************************************************************************/

CdropdownDlg::CdropdownDlg(CWnd* pParent /*=NULL*/)
        : CDialog(CdropdownDlg::IDD, pParent)
   {
        m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
        showing = FALSE;
   }

/****************************************************************************
*                        CdropdownDlg::DoDataExchange
* Inputs:
*       CDataExchange * pDX:
* Result: void
*       
* Effect: 
*       Initializes the controls
****************************************************************************/

void CdropdownDlg::DoDataExchange(CDataExchange* pDX)
   {
   CDialog::DoDataExchange(pDX);
   DDX_Control(pDX, IDC_WINDOW, c_Window);
   DDX_Control(pDX, IDC_SCREEN, c_Screen);
   DDX_Control(pDX, IDC_COMBO1, c_Combo);
   DDX_Control(pDX, IDC_SM_VIRTUAL, c_SM_VIRTUAL);
   DDX_Control(pDX, IDC_MONITORINFO, c_MONITORINFO);
   DDX_Control(pDX, IDC_MONITORS, c_Monitors);
   DDX_Control(pDX, IDC_MOUSECLIENT, c_MouseClient);
   DDX_Control(pDX, IDC_MOUSESCREEN, c_MouseScreen);
   DDX_Control(pDX, IDC_MOUSESCREENTOVIRTUAL, c_MouseScreenToVirtual);
   DDX_Control(pDX, IDC_MOUSEVIRTUALTOSCREEN, c_MouseVirtualToScreen);
   DDX_Control(pDX, IDC_MOUSETEST, c_MouseTest);
   DDX_Control(pDX, IDC_LIMITS, c_Limits);
   DDX_Control(pDX, IDC_TOP_LIMIT, c_LimitTop);
   DDX_Control(pDX, IDC_RIGHT_LIMIT, c_LimitRight);
   DDX_Control(pDX, IDC_LEFT_LIMIT, c_LimitLeft);
   DDX_Control(pDX, IDC_BOTTOM_LIMIT, c_LimitBottom);
   DDX_Control(pDX, IDC_FAST, c_Fast);
   DDX_Control(pDX, IDC_SLOW, c_Slow);
   DDX_Control(pDX, IDC_DROPPED, c_Dropped);
   DDX_Control(pDX, IDC_LIST, c_List);
   }

/****************************************************************************
*                                 Message Map
****************************************************************************/

BEGIN_MESSAGE_MAP(CdropdownDlg, CDialog)
        ON_WM_SYSCOMMAND()
        ON_WM_PAINT()
        ON_WM_QUERYDRAGICON()
        ON_MESSAGE(WM_DISPLAYCHANGE, OnDisplayChange)
        ON_WM_MOVE()
        ON_WM_CLOSE()
        ON_CBN_DROPDOWN(IDC_COMBO1, OnCbnDropdownCombo1)
        ON_REGISTERED_MESSAGE(UWM_TEST_MOUSEMOVE, OnUserMouseMove)
        ON_REGISTERED_MESSAGE(UWM_HOOK_MOUSEMOVE, OnHookMouseMove)
        ON_WM_DESTROY()
        ON_BN_CLICKED(IDC_LIMITS, OnBnClickedLimits)
        ON_WM_TIMER()
END_MESSAGE_MAP()


// CdropdownDlg message handlers

/****************************************************************************
*                         CdropdownDlg::OnInitDialog
* Result: BOOL
*       TRUE, always
* Effect: 
*       Initializes the dialog
****************************************************************************/

BOOL CdropdownDlg::OnInitDialog()
   {
    CDialog::OnInitDialog();

    // Add "About..." menu item to system menu.

    // IDM_ABOUTBOX must be in the system command range.
    ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
    ASSERT(IDM_ABOUTBOX < 0xF000);

    CMenu* pSysMenu = GetSystemMenu(FALSE);
    if (pSysMenu != NULL)
       {
        CString strAboutMenu;
        strAboutMenu.LoadString(IDS_ABOUTBOX);
        if (!strAboutMenu.IsEmpty())
           {
            pSysMenu->AppendMenu(MF_SEPARATOR);
            pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
           }
       }

    // Set the icon for this dialog.  The framework does this automatically
    //  when the application's main window is not a dialog
    SetIcon(m_hIcon, TRUE);                 // Set big icon
    SetIcon(m_hIcon, FALSE);                // Set small icon

    // TODO: Add extra initialization here

    CFont * f = GetFont();
    ASSERT(f != NULL);

    LOGFONT lf;
    f->GetLogFont(&lf);
    _tcscpy(lf.lfFaceName, _T("Courier New"));
    font.CreateFontIndirect(&lf);
    
    c_Monitors.SetFont(&font);
    
    monitors.Initialize();
    c_Combo.AddString(_T("1234567890"));
    c_Combo.AddString(_T("123456789012345678901234567890123456789012345678901234567890"));
    CString lines = _T("123456789012345678901234567890123456789012345678901234567890123456789012345678901234567890123456789012345678901234567890123456789012345678901234567890123456789012345678901234567890");
    c_Combo.AddString(lines);
    lines += lines;
    c_Combo.AddString(lines);
    lines += lines;
    c_Combo.AddString(lines);
    ShowMonitors();

    CString s;
    s.LoadString(IDS_TEST_HERE);
    c_MouseTest.SetWindowText(s);

    c_MouseClient.SetWindowText(_T(""));
    c_MouseScreen.SetWindowText(_T(""));
    c_MouseScreenToVirtual.SetWindowText(_T(""));
    c_MouseVirtualToScreen.SetWindowText(_T(""));

    CString extclass = AfxRegisterWndClass(0,               // class styles
                                           0,               // cursor
                                           (HBRUSH)COLOR_INFOBK,  // background
                                           0);              // icon
    for(int i = 0; i < 4; i++)
       { /* extenders */
        VERIFY(extenders[i].CreateEx(0,                     // extended style
                                     extclass,              // class name
                                     NULL,                  // caption text
                                     WS_POPUP               // top-level window,
                                                            // not visible, no caption, minimize, maximize, etc.
                                     ,0, 0, 0, 0,           // very small to start
                                     m_hWnd,                // no parent HWND
                                     NULL));                // no parent menu
        extenders[i].ModifyStyle(WS_CAPTION, 0);
        DWORD style = extenders[i].GetStyle();
        ASSERT(!(style & WS_CAPTION));
       } /* extenders */

    extenders[RIGHT_LIMIT_INDEX].SetDirection(CExtenders::Right);
    extenders[LEFT_LIMIT_INDEX].SetDirection(CExtenders::Left);
    extenders[TOP_LIMIT_INDEX].SetDirection(CExtenders::Top);
    extenders[BOTTOM_LIMIT_INDEX].SetDirection(CExtenders::Bottom);

    CheckRadioButton(IDC_SLOW, IDC_FAST, IDC_FAST);

    VERIFY(setMyHook(m_hWnd));

    return TRUE;  // return TRUE  unless you set the focus to a control
   }

/****************************************************************************
*                         CdropdownDlg::OnSysCommand
* Inputs:
*       UINT nID: System command ID
*       LPARAM lParam: parameter
* Result: void
*       
* Effect: 
*       Handles the about box in the system menu
****************************************************************************/

void CdropdownDlg::OnSysCommand(UINT nID, LPARAM lParam)
   {
    if ((nID & 0xFFF0) == IDM_ABOUTBOX)
       {
        CAboutDlg dlgAbout;
        dlgAbout.DoModal();
       }
    else
       {
        CDialog::OnSysCommand(nID, lParam);
       }
   }

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CdropdownDlg::OnPaint() 
{
        if (IsIconic())
        {
                CPaintDC dc(this); // device context for painting

                SendMessage(WM_ICONERASEBKGND, reinterpret_cast<WPARAM>(dc.GetSafeHdc()), 0);

                // Center icon in client rectangle
                int cxIcon = GetSystemMetrics(SM_CXICON);
                int cyIcon = GetSystemMetrics(SM_CYICON);
                CRect rect;
                GetClientRect(&rect);
                int x = (rect.Width() - cxIcon + 1) / 2;
                int y = (rect.Height() - cyIcon + 1) / 2;

                // Draw the icon
                dc.DrawIcon(x, y, m_hIcon);
        }
        else
        {
                CDialog::OnPaint();
        }
}

// The system calls this function to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CdropdownDlg::OnQueryDragIcon()
{
        return static_cast<HCURSOR>(m_hIcon);
}

/****************************************************************************
*                             CdropdownDlg::OnOK
*                           CdropdownDlg::OnCancel
* Result: void
*       
* Effect: 
*       No effect.  Or, contrariwise, the effect is to disable <enter> and
*       <esc> keys as means of closing the dialog
****************************************************************************/


void CdropdownDlg::OnOK()
    {
    }

void CdropdownDlg::OnCancel()
    {
    }

void CdropdownDlg::OnClose()
    {
     CDialog::OnOK();
    }

/****************************************************************************
*                           CdropdownDlg::Show
* Inputs:
*       const CRect & r: A rectangle to be formatted
*       CStatic & ctl: Control into which to place formatted string
* Result: void
*       
* Effect: 
*       Formats the string and puts it in the control
****************************************************************************/

void CdropdownDlg::Show(const CRect & r, CStatic & ctl)
    {
     CString s;
     s.Format(_T("x,y=(%d, %d)  w,h=(%d, %d)"), r.left, r.top, r.Width(), r.Height());
     CString old;
     ctl.GetWindowText(old);
     if(old != s)
        ctl.SetWindowText(s);
    }

/****************************************************************************
*                           CdropdownDlg::Show
* Inputs:
*       const CPoint & r: A rectangle to be formatted
*       CStatic & ctl: Control into which to place formatted string
* Result: void
*       
* Effect: 
*       Formats the string and puts it in the control
****************************************************************************/

void CdropdownDlg::Show(const CPoint & pt, CStatic & ctl)
    {
     CString s;
     s.Format(_T("(%d, %d)"), pt.x, pt.y);
     CString old;
     ctl.GetWindowText(old);
     if(old != s)
        ctl.SetWindowText(s);
    }

/****************************************************************************
*                            CdropdownDlg::OnMove
* Inputs:
*       int x: new x position
*       int y: new y position
* Result: void
*       
* Effect: 
*       Updates the displays as the window moves around
****************************************************************************/

void CdropdownDlg::OnMove(int x, int y)
    {
    CDialog::OnMove(x, y);

     if(c_Combo.GetSafeHwnd() != NULL)
         {
          CRect r;
          c_Combo.GetWindowRect(&r);
          Show(r, c_Screen);
          ScreenToClient(&r);
          Show(r, c_Window);
          WhichMonitor(r);
         }
     if(showing)
        { /* kill show */
         KillTimer(IDT_SHOWTIME);
         Unshow();
         updateControls();
        } /* kill show */
    }

/****************************************************************************
*                         CdropdownDlg::WhichMonitor
* Inputs:
*       CRect & r: OUT: Rectangle in screen coordinates
* Result: void
*       
* Effect: 
*       Displays the rectangle for the monitor, and returns it via the
*       reference parameter
****************************************************************************/

void CdropdownDlg::WhichMonitor(CRect & r)
    {
     c_Combo.GetWindowRect(&r);
     CPoint pt(r.left, r.top);
     HMONITOR monitor = ::MonitorFromPoint(pt, MONITOR_DEFAULTTONULL);
     if(monitor == NULL)
         return;

     MONITORINFO info = {sizeof(MONITORINFO)};
     BOOL b = ::GetMonitorInfo(monitor, &info);
     ASSERT(b);
     if(!b)
         return;
     Show(info.rcMonitor, c_MONITORINFO);

    }

/****************************************************************************
*                      CdropdownDlg::OnCbnDropdownCombo1
* Result: void
*       
* Effect: 
*       Resizes the dropdown to extend as far to the right as it can
****************************************************************************/

void CdropdownDlg::OnCbnDropdownCombo1()
    {
     CRect r;
     c_Combo.GetDroppedControlRect(&r);
     
     Show(r, c_Dropped);
     
#if WINVER >= 0x501  // requires Windows XP or higher
     COMBOBOXINFO info = {sizeof(COMBOBOXINFO)};
     if(c_Combo.GetComboBoxInfo(&info))
        { /* succeeded */
         CRect w;
         CWnd * list = CWnd::FromHandle(info.hwndList);
         list->GetWindowRect(&w);
         Show(w, c_List);

         CRect ctl;
         c_Combo.GetWindowRect(&ctl);
         
         CPoint pt1(w.left, ctl.bottom);
         CPoint pt2(w.left, ctl.bottom + w.Height());

         if(monitors.RightLimitFrom(pt1) && monitors.RightLimitFrom(pt2))
            { /* got limit */
             int x = min(pt1.x, pt2.x);
             int width = x - w.left - ::GetSystemMetrics(SM_CXVSCROLL);
             c_Combo.SetDroppedWidth(width);
            } /* got limit */
        } /* succeeded */
     else
        { /* failed */
         // the combo box has fallen off the screen
         c_Combo.PostMessage(CB_SHOWDROPDOWN, FALSE);
         c_Combo.PostMessage(CB_SHOWDROPDOWN, TRUE);
        } /* failed */
#else // Windows 2000
     CPoint pt1(r.left, r.top);
     CPoint pt2(r.left, r.bottom);

     if(monitors.RightLimitFrom(pt1) && monitors.RightLimitFrom(pt2))
        { /* got limit */
         int x = min(pt1.x, pt2.x);
         int width = x - r.left - ::GetSystemMetrics(SM_CXVSCROLL);
         c_Combo.SetDroppedWidth(width);
         c_Combo.ShowDropDown(FALSE);
         c_Combo.PostMessage(CB_SHOWDROPDOWN, TRUE);
         //c_Combo.ShowDropDown(TRUE);
        } /* got limit */
     
#endif
    }

/****************************************************************************
*                          CdropdownDlg::monitorproc
* Inputs:
*       HMONITOR monitor:
*       HDC: ignored
*       LPRECT: ignored
* Result: BOOL
*       TRUE to continue iteration
*       FALSE to terminate iteration
* Effect: 
*       Adds each of the monitors into the list of available monitors
****************************************************************************/

BOOL CdropdownDlg::monitorproc(HMONITOR monitor, HDC, LPRECT rect)
    {
     CString s;
     MONITORINFOEX info;
     info.cbSize = sizeof(info);
     VERIFY(::GetMonitorInfo(monitor, (LPMONITORINFO)&info));
     s.Format(_T("%s (x %5d, y %5d) [w %5d, h %5d]"), 
         info.szDevice, 
         info.rcMonitor.left, 
         info.rcMonitor.top,
         info.rcMonitor.right - info.rcMonitor.left,
         info.rcMonitor.bottom - info.rcMonitor.top);
     c_Monitors.AddString(s);
     return TRUE;
    }

/* static */ BOOL CALLBACK CdropdownDlg::monitorproc(HMONITOR monitor, HDC dc, LPRECT rect, LPARAM data)
    {
     CdropdownDlg * self = (CdropdownDlg *)data;
     return self->monitorproc(monitor, dc, rect);
    }

/****************************************************************************
*                         CdropdownDlg::ShowMonitors
* Result: void
*       
* Effect: 
*       Called whenever there is a display change to redisplay all the monitors
****************************************************************************/

void CdropdownDlg::ShowMonitors()
    {
     int x = ::GetSystemMetrics(SM_CXVIRTUALSCREEN);
     int y = ::GetSystemMetrics(SM_CYVIRTUALSCREEN);
     CString s;
     s.Format(_T("x=%d y=%d"), x, y);
     c_SM_VIRTUAL.SetWindowText(s);
     c_Monitors.ResetContent();
     ::EnumDisplayMonitors(NULL, NULL, monitorproc, (LPARAM)this);
    }

/****************************************************************************
*                        CdropdownDlg::OnDisplayChange
* Inputs:
*       WPARAM: ignored
*       LPARAM: ignored
* Result: LRESULT
*       0, always
* Effect: 
*       Updates the list of available monitors
****************************************************************************/

LRESULT CdropdownDlg::OnDisplayChange(WPARAM, LPARAM)
    {
     ShowMonitors();
     monitors.Initialize();
     return 0;
    }

/****************************************************************************
*                        CdropdownDlg::OnUserMouseMove
* Inputs:
*       WPARAM: flags
*       LPARAM: (LPARAM)(POINTS)
* Result: LRESULT
*       Logically void, 0, always
* Effect: 
*       Handles mouse update
****************************************************************************/

LRESULT CdropdownDlg::OnUserMouseMove(WPARAM wParam, LPARAM lParam)
    {
     CPoint pt;
     POINTSTOPOINT(pt, MAKEPOINTS(lParam));

     Show(pt, c_MouseClient);

     c_MouseTest.ClientToScreen(&pt);

     ShowMouse(pt);
     return 0;
    } // CdropdownDlg::OnUserMouseMove

/****************************************************************************
*                           CdropdownDlg::ShowMouse
* Inputs:
*       CPoint pt: point
* Result: void
*       
* Effect: 
*       Shows the screen mappings
****************************************************************************/

void CdropdownDlg::ShowMouse(CPoint pt)
    {
     Show(pt, c_MouseScreen);

     if(monitors.ScreenToVirtual(pt))
        Show(pt, c_MouseScreenToVirtual);
     else
        { /* failed */
         DWORD err = ::GetLastError();
         c_MouseScreenToVirtual.SetWindowText(ErrorString(err));
        } /* failed */

     if(monitors.VirtualToScreen(pt))
        Show(pt, c_MouseVirtualToScreen);
     else
        { /* failed vts */
         DWORD err = ::GetLastError();
         c_MouseVirtualToScreen.SetWindowText(ErrorString(err));
        } /* failed vts */
    } // CdropdownDlg::ShowMouse

/****************************************************************************
*                           CdropdownDlg::OnDestroy
* Result: void
*       
* Effect: 
*       Frees up the hook
****************************************************************************/

void CdropdownDlg::OnDestroy()
    {
     CDialog::OnDestroy();

     clearMyHook(m_hWnd);
    }

/****************************************************************************
*                        CdropdownDlg::OnHookMouseMove
* Inputs:
*       WPARAM: flags
*       LPARAM: (LPARAM)(POINTS) mouse position
* Result: LRESULT
*       Logically void, 0, always
* Effect: 
*       Updates the mouse from hook notifications
****************************************************************************/

LRESULT CdropdownDlg::OnHookMouseMove(WPARAM, LPARAM lParam)
    {
     CPoint pt;
     POINTSTOPOINT(pt, MAKEPOINTS(lParam));

     GetCursorPos(&pt);

     CRect r;
     c_MouseTest.GetWindowRect(&r);
     if(!r.PtInRect(pt))
        c_MouseClient.SetWindowText(_T(""));
     
     ShowMouse(pt);
     return 0;
    } // CdropdownDlg::OnHookMouseMove

/****************************************************************************
*                       CdropdownDlg::OnBnClickedLimits
* Result: void
*       
* Effect: 
*       Shows the limits
****************************************************************************/

void CdropdownDlg::OnBnClickedLimits()
    {
     CRect r;
     c_Limits.GetWindowRect(&r);

     CPoint pt;

     SetWindowPos(&wndTopMost, 0, 0, 0, 0, SWP_NOMOVE | SWP_NOSIZE);
     pt.x = r.right;
     pt.y = r.top;
     if(monitors.RightLimitFrom(pt))
        { /* can extend */
         Show(pt, c_LimitRight);
         extenders[RIGHT_LIMIT_INDEX].SetWindowPos(&wndTopMost, r.right, r.top, pt.x - r.right, r.Height(), 0);
         extenders[RIGHT_LIMIT_INDEX].ShowWindow(SW_SHOW);
        } /* can extend */
     else
        { /* failed right */
         DWORD err = ::GetLastError();
         c_LimitRight.SetWindowText(ErrorString(err));
        } /* failed right */

     pt.x = r.left;
     pt.y = r.top;
     if(monitors.LeftLimitFrom(pt))
        { /* can extend left */
         Show(pt, c_LimitLeft);
         extenders[LEFT_LIMIT_INDEX].SetWindowPos(&wndTopMost, pt.x, r.top, r.left - pt.x, r.Height(), 0);
         extenders[LEFT_LIMIT_INDEX].ShowWindow(SW_SHOW);
        } /* can extend left */
     else
        { /* failed left */
         DWORD err = ::GetLastError();
         c_LimitLeft.SetWindowText(ErrorString(err));
        } /* failed left */

     pt.x = r.left;
     pt.y = r.top;
     if(monitors.TopLimitFrom(pt))
        { /* can extend up */
         Show(pt, c_LimitTop);
         extenders[TOP_LIMIT_INDEX].SetWindowPos(&wndTopMost, r.left, pt.y, r.Width(), r.top - pt.y, 0);
         extenders[TOP_LIMIT_INDEX].ShowWindow(SW_SHOW);
        } /* can extend up */
     else
        { /* failed up */
         DWORD err = ::GetLastError();
         c_LimitTop.SetWindowText(ErrorString(err));
        } /* failed up */

     pt.x = r.left;
     pt.y = r.bottom;
     if(monitors.BottomLimitFrom(pt))
        { /* can extend down */
         Show(pt, c_LimitBottom);
         extenders[BOTTOM_LIMIT_INDEX].SetWindowPos(&wndTopMost, r.left, r.bottom, r.Width(), pt.y - r.bottom, 0);
         extenders[BOTTOM_LIMIT_INDEX].ShowWindow(SW_SHOW);
        } /* can extend down */
     else
        { /* failed down */
         DWORD err = ::GetLastError();
         c_LimitBottom.SetWindowText(ErrorString(err));
        } /* failed down */
     showing = TRUE;

     DWORD time = SHOWTIME_FAST;
     
     if(c_Slow.GetCheck() == BST_CHECKED)
        time = SHOWTIME_SLOW;
     
     SetTimer(IDT_SHOWTIME, time, NULL);
     updateControls();
    }

/****************************************************************************
*                            CdropdownDlg::Unshow
* Result: void
*       
* Effect: 
*       Hidees all the winodws
****************************************************************************/

void CdropdownDlg::Unshow()
    {
     SetWindowPos(&wndNoTopMost, 0, 0, 0, 0, SWP_NOMOVE | SWP_NOSIZE);
     for(int i = 0; i < 4; i++)
        if(extenders[i].GetSafeHwnd() != NULL)
           extenders[i].ShowWindow(SW_HIDE);
     showing = FALSE;
    } // CdropdownDlg::Unshow

/****************************************************************************
*                            CdropdownDlg::OnTimer
* Inputs:
*       UINT nIDEvent:
* Result: void
*       
* Effect: 
*       Kills the timer and hides the windows
****************************************************************************/

void CdropdownDlg::OnTimer(UINT nIDEvent)
    {
     switch(nIDEvent)
        { /* events */
         case IDT_SHOWTIME:
            Unshow();
            KillTimer(IDT_SHOWTIME);
            updateControls();
            break;
        } /* events */

     CDialog::OnTimer(nIDEvent);
    }

/****************************************************************************
*                        CdropdownDlg::updateControls
* Result: void
*       
* Effect: 
*       Updates the controls
****************************************************************************/

void CdropdownDlg::updateControls()
    {
     c_Limits.EnableWindow(!showing);
    } // CdropdownDlg::updateControls
